<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Practice</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css"
          rel="stylesheet"
          integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3"
          crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/lodash@4.17.21/lodash.min.js"
            integrity="sha256-qXBd/EfAdjOA2FGrGAG+b3YBn2tn5A6bhz+LSgYD96k="
            crossorigin="anonymous"></script>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.7.2/font/bootstrap-icons.css">
    <style>
        .todo-item--input:focus {
            outline: none;
            border-bottom: 1px solid black;
        }

        .todo-item--input {
            border: 0;
            border-bottom: 1px solid white;
        }

        .line-through {
            text-decoration: line-through;
        }

        .todo-item--checkbox {
            width: 20px;
            height: 20px;
        }
    </style>
</head>
<body>
<div>
    <div class="container">
        <h1>To do list</h1>
        <div class="row">
            <div class="col-8">
                <div class="input-group">
                    <input oninput="removeError()" id="todo-input" class="w-100 form-control" type="text" value="" placeholder="Input todo"/>
                </div>
            </div>
            <div class="col-4">
                <button onclick="addTodoList()" type="button" class="btn btn-success">Add todo</button>
            </div>
        </div>
        <div id="todo-items" class="todo-list mt-4">
        </div>
    </div>
</div>

<script>
    const TODO_LIST = 'TODO_LIST';
    const TODO_LIST_SEQUENCE = 'TODO_LIST_SEQ';
    const INVALID_INPUT_CLASSNAME = 'is-invalid';

    const toDoInput = document.getElementById('todo-input');

    toDoInput.addEventListener('keyup', function (event) {
        if (event.key === 'Enter') {
            event.preventDefault();
            addTodoList();
        }
    });

    document.addEventListener("DOMContentLoaded", function (event) {
        refreshList();
    });

    let isInputInvalid = false;
    function addTodoList() {
        const inputTodo = toDoInput.value;
        if (inputTodo.trim().length === 0) {
            isInputInvalid = true;
            if (!toDoInput.classList.contains(INVALID_INPUT_CLASSNAME)) {
                toDoInput.className += ' ' + INVALID_INPUT_CLASSNAME;
            }
            return;
        }
        saveTodoItem({
            done: false,
            value: inputTodo,
            createdAt: new Date()
        });
        toDoInput.value = "";
        refreshList();
    }

    function removeError() {
        if (isInputInvalid) {
            isInputInvalid = false;
            toDoInput.className = toDoInput.className.replaceAll(INVALID_INPUT_CLASSNAME, '').trim();
        }
    }

    function saveTodoItem(item) {
        let savedItems = getSavedTodoItems();
        savedItems.push({
            ...item,
            id: getNextSequence()
        });
        saveTodoItems(savedItems);
    }

    function saveTodoItems(savedItems) {
        localStorage.setItem(TODO_LIST, JSON.stringify(savedItems));
    }

    function refreshList() {
        const savedItems = getSavedTodoItems();
        if (savedItems.length === 0) {
            document.getElementById('todo-items').innerHTML = '<div class="text-center">No items</div>';
            return;
        }
        const doneItems = savedItems.filter(item => item.done);
        const notDoneItems = savedItems.filter(item => !item.done);
        const sortItems = [];
        sortItems.push(...(_.sortBy(notDoneItems, ['createdAt'])).reverse())
        sortItems.push(...(_.sortBy(doneItems, ['doneAt'])).reverse())
        let elements = '';
        for (const item of sortItems) {
            const todoCheckboxId = `todo-item-checkbox-${item.id}`;
            const todoInputId = `todo-item--input-${item.id}`;
            elements = elements.concat(`<div class="todo-item row mt-2">
                <div class="col-1 d-flex justify-content-center align-items-center">
                    <input onchange="tick('${todoCheckboxId}', '${item.id}')" class="todo-item--checkbox" type="checkbox" id="${todoCheckboxId}" name="${todoCheckboxId}" ${item.done ? 'checked' : ''}>
                    <i onclick="deleteTodoItem('${item.id}')" style="margin-left: 3px; cursor: pointer;" class="bi bi-trash ml-2"></i>
                </div>
                <div class="col-11">
                    <input oninput="updateTodoValue('${todoInputId}', '${item.id}')" id="${todoInputId}" type="text" class="w-100 todo-item--input ${item.done ? 'line-through' : ''}" value="${item.value}" />
                </div>
            </div>`)
        }
        document.getElementById('todo-items').innerHTML = elements;
    }

    function updateTodoValue(elementId, itemId) {
        const todoInputItem = document.getElementById(elementId)
        if (!todoInputItem) {
            console.log('can not find to do input item element. elementId=' + elementId)
            return;
        }
        let savedItem = getTodoItemById(itemId);
        if (!savedItem) {
            console.log('can not find saved to do item. itemId=' + itemId)
            return;
        }
        
        const value = todoInputItem.value;
        updateTodoItem(itemId, {
            ...savedItem,
            value
        });
    }
    
    function tick(elementId, itemId) {
        const todoCheckboxItem = document.getElementById(elementId)
        if (!todoCheckboxItem) {
            console.log('can not find to do checkbox item element. elementId=' + elementId)
            return;
        }
        let savedItem = getTodoItemById(itemId);
        if (!savedItem) {
            console.log('can not find saved to do item. itemId=' + itemId)
            return;
        }
        const checked = todoCheckboxItem.checked;
        updateTodoItem(itemId, {
            ...savedItem,
            done: checked,
            doneAt: new Date()
        });
        refreshList();
    }

    function getTodoItemById(id) {
        const savedItems = getSavedTodoItems();
        return savedItems.find(item => item.id === parseInt(id));
    }

    function updateTodoItem(id, todoItem) {
        const savedItems = getSavedTodoItems();
        let savedItem = savedItems.find(item => item.id === parseInt(id));
        if (!savedItem) {
            console.log('Can not update todo item')
            return;
        }
        savedItem.value = todoItem.value;
        savedItem.done = todoItem.done;
        savedItem.doneAt = todoItem.doneAt
        saveTodoItems(savedItems);
    }

    function deleteTodoItem(id) {
        let savedItems = getSavedTodoItems();
        savedItems = savedItems.filter(item => item.id !== parseInt(id));
        saveTodoItems(savedItems);
        refreshList()
    }

    function getSavedTodoItems() {
        let savedItems = localStorage.getItem(TODO_LIST);
        if (!savedItems) {
            return [];
        }
        return JSON.parse(savedItems);
    }

    function getNextSequence() {
        let itemSequence = localStorage.getItem(TODO_LIST_SEQUENCE);
        let nextSeq;
        if (!itemSequence) {
            nextSeq = 1;
        } else {
            nextSeq = parseInt(itemSequence) + 1;
        }
        localStorage.setItem(TODO_LIST_SEQUENCE, JSON.stringify(nextSeq));
        return nextSeq;
    }

</script>
</body>

</html>
